//+--------------------------------------------------------------------------------------------+
//|   Klinger.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_separate_window
#include <stdlib.mqh>
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//#property indicator_minimum -1500
//#property indicator_maximum 1500

double CurrPrice,PrevPrice;
int CurrTrend,PrevTrend;
double CurrCM,PrevCM,CurrDM,PrevDM;

double KVO[];
double Signal[];

double vForce[25000];
double KVO34[25000];
double KVO55[25000];

int init()
{
      
   IndicatorBuffers(2);

   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,3,Green);
   SetIndexBuffer(0,KVO);
   
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,Red);
   SetIndexBuffer(1,Signal);
   
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); //---- check for possible errors
   if(counted_bars>0) counted_bars--; //---- last counted bar will be recounted
   int limit = Bars-counted_bars;

   ArraySetAsSeries(vForce,true);   
   ArraySetAsSeries(KVO34,true);   
   ArraySetAsSeries(KVO55,true);   

   for(int i=0; i<limit; i++)
   {
      CurrPrice = (High[i]+Low[i]+Close[i])/3;
      
      if (CurrPrice > PrevPrice)
      {CurrTrend = 1;}
      else
      {CurrTrend = -1;}
      
      CurrDM = High[i]-Low[i];
      
      if (CurrTrend == PrevTrend)
      {CurrCM = PrevCM+CurrDM;}
      else
      {CurrCM = PrevDM+CurrDM;}
      
      vForce[i] = Volume[i]*CurrTrend*MathAbs(2*CurrDM/CurrCM-1);

      PrevPrice = CurrPrice;
      PrevTrend = CurrTrend;
      PrevCM = CurrCM;
      PrevDM = CurrDM;
   }           
   for (i=0;i<limit;i++)
   {
      KVO34[i] = iMAOnArray(vForce,0,34,0,MODE_EMA,i);      
      KVO55[i] = iMAOnArray(vForce,0,55,0,MODE_EMA,i);      
      KVO[i] = KVO55[i]-KVO34[i];
   }      
   for (i=0;i<limit;i++)
   {
      Signal[i] = iMAOnArray(KVO,0,13,0,MODE_EMA,i);      
   }      
   
   return(0);

}
//+--------------------------------------------------------------------------------------------+